/*-------------------------------------+-------------------------------------*/
/*                                   show.c                                  */

#include <iostream.h>
#include "hardbord.h"

static inline char low (char c)
{
   return ('A'<=c && c<='Z') ? c+'a'-'A' : c;
}

void hardboard::show_fen (void)
{
   for (unsigned i=7; i<8; i--) {
      for (unsigned j=0; j<8; j++)
         if (board[8*i+j].occ) {
            piece * p = board[8*i+j].occ;
            cout << ((p->dark) ? low(lang[p->type]) : lang[p->type]);
         } else {
            unsigned k;
            for (k=0; ! board[8*i+j].occ && j<8; k++)
               j++;
            cout << k;
            j--;
         }
      if (i)
         cout << '/';
   }
   cout << ' ';

   cout << (color ? 'B' : 'W') << ' ';

   if (specials.OOwhite)
      cout << lang[KING];
   if (specials.OOOwhite)
      cout << lang[QUEEN];
   if (specials.OOblack)
      cout << low(lang[KING]);
   if (specials.OOOblack)
      cout << low(lang[QUEEN]);
   if (! specials.OOwhite && ! specials.OOOwhite &&
      ! specials.OOblack && ! specials.OOOblack)
      cout << "nil";
   cout << ' ';

   if (specials.epfield) {
      cout << char ((specials.epfield-board) % 8 + 'a');
      cout << char ((specials.epfield-board) / 8 + '1');
   } else
      cout << "nil";
   cout << ' ';

   cout << move50 << ' ';

   cout << move_n << endl;
   return;
}

void hardboard::show_board (void)
{
   cout << "+----------------+" << endl;
   for (unsigned i=8; i; i--) {
      cout << '|';
      for (unsigned j=0; j<8; j++) {
         piece * p = board[8*i-8+j].occ;
         cout << ((p) ? (p->dark) ? low(lang[p->type]) : lang[p->type] : ' ');
         cout << ' ';
      }
      cout << '|' << endl;
   }
   cout << "+----------------+" << endl;
   return;
}

void hardboard::show_lan (void)
{
   for (unsigned n=0; n<n_moves; n++) {
      cout << lanlist[n];
      if ((n+1) % 5)
         cout << " \t";
      else
         cout << endl;
   }
   cout << endl;
   return;
}

void hardboard::show_san (void)
{
   for (unsigned n=0; n<n_moves; n++) {
      cout << sanlist[n];
      if ((n+1) % 10)
         cout << '\t';
      else
         cout << endl;
   }
   cout << endl;
   return;
}

